<script setup>
    import {inject  } from 'vue'
 
    const dayjs = inject('dayjs') 
    const axios = inject('axios')
    const emit = defineEmits(['submit_success'])
    defineProps({
        lections: {type:Array, required: true},      
    })

    function createReservation(lectionId){
        
        axios.post(`${localStorage.getItem("username")}/reservations`,{
            params:{
            lection_id :lectionId,
            jwt_token:localStorage.getItem("jwt"),
            }
        }).then( function(response){
            if (response.status === 200){
            emit('submit_success')
            }
        })
        }
        
    

    function formatDate(date){
        let formatedDate = dayjs(date).format('H:mm')
        return formatedDate
    }
  
</script>

<template>
    <div class="mt-4">
    <table v-if="lections.length" class="w-full text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
        <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>

                <th scope="col" class="px-6 py-3">
                    Lection Name
                </th>
                <th scope="col" class="px-6 py-3">
                    Room
                </th>
                <th scope="col" class="px-6 py-3">
                    Trainer
                </th>
                <th scope="col" class="px-6 py-3">
                    Capacity
                </th>
                <th scope="col" class="px-6 py-3">
                    Time
                </th>
                <th scope="col" class="px-6 py-3">
                    Reserve
                </th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="lection in lections"
            
            class="bg-white border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-50 dark:hover:bg-gray-600">
                <th scope="row" class="flex items-center px-6 py-4 text-gray-900 whitespace-nowrap dark:text-white">
                    <div class="ps-3">
                        <div class="text-base font-semibold">{{lection.name}}</div>
                    </div>  
                </th>
                <td class="px-6 py-4">
                    {{lection.room_name}}
                </td>
                <td class="px-6 py-4">
                    <div class="flex items-center">
                        {{lection.tranier_name}}
                    </div>
                </td>
                <td class="px-6 py-4">
                    {{lection.clients + ' / ' + lection.max_capacity}}
                </td>
                <td class="px-6 py-4">
                {{ formatDate(lection.start_time) + ' - ' + formatDate(lection.end_time) }}
                </td>
                <td class="px-6 py-4">
                    <button 
                            @click="createReservation(lection.id)"
                            :disabled="dayjs().isAfter(dayjs(lection.start_time)) || (lection.clients > lection.max_capacity)" 
                            :class="{'bg-gray-100 text-gray-600': dayjs().isAfter(dayjs(lection.start_time)) || (lection.clients >= lection.max_capacity),
                                        'hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 text-white bg-blue-600': dayjs().isBefore(dayjs(lection.start_time)) || (lection.clients < lection.max_capacity)}"
                    type="button" class="font-medium rounded-lg text-sm px-4 py-1.5 ">Reserve</button>
                </td>
            </tr>
        </tbody>
    </table>
    <div v-if="!lections.length" class="p-4 my-4 text-sm text-yellow-800 rounded-lg bg-yellow-50">
        <span class="font-medium">Info </span> No training at selected day and room
    </div>
    </div>
</template>